      subroutine gridset(xface,yface,zface,rhokap,xmax,ymax,zmax,kappa)

      implicit none

      include 'grid.txt'

      real xmax,ymax,zmax,kappa

      integer i,j,k
      real x,y,z,rho,rhosum,dV,taueq,taupole

      print *, 'Setting up density grid....'

c*********************************************************************
c**********  Linear Cartesian grid. Set up grid faces ****************
c*********************************************************************
      do i=1,nxg+1
         xface(i)=(i-1)*2.*xmax/nxg
      end do
      do i=1,nyg+1
         yface(i)=(i-1)*2.*ymax/nyg
      end do
      do i=1,nzg+1
         zface(i)=(i-1)*2.*zmax/nzg
      end do
c**********************************************************************

      rhosum=0.
c**************  Loop through x, y, and z to set up grid density.  ****
      do i=1,nxg
       do j=1,nyg
        do k=1,nzg
           x=xface(i)-xmax+xmax/nxg
           y=yface(j)-ymax+ymax/nyg
           z=zface(k)-zmax+zmax/nzg

c**********************Call density setup subroutine *****************
           call density(x,y,z,rho)
           rhokap(i,j,k)=rho*kappa*1.5e13 ! rho*kappa*R, R=1AU=1.5e13cm

           rhosum=rhosum+rhokap(i,j,k)/(kappa*1.5e13)
c*********************************************************************

        end do
       end do
      end do
c*********************************************************************

      dV=2.*xmax/nxg
      dV=dV*2.*ymax/nyg
      dV=dV*2.*zmax/nzg
      dV=dV*1.5e13
      dV=dV/2.e33  ! dV/M_sun
      dV=dV*1.5e13
      dV=dV*1.5e13

      print *,'Mass (M_sun) = ',rhosum*dV

c****************** Calculate equatorial and polar optical depths ****
      taueq=0.
      taupole=0.
      do i=1,nxg
         taueq=taueq+rhokap(i,nyg/2,nzg/2)
      enddo
      do i=1,nzg
         taupole=taupole+rhokap(nxg/2,nyg/2,i)
      enddo
      taueq=taueq*2.*xmax/nxg
      taupole=taupole*2.*zmax/nzg
      print *,'taueq = ',taueq,'  taupole = ',taupole

c************** Write out cut through density grid *******************
c      open(unit=10,file='rhoxz.dat',status='unknown')
c        do i=1,nyg
c           write(10,*) (rhokap(k,nyg/2+1,i),k=1,nxg)
c        end do
c      close(10)

      return
      end
